//
// button
// ce_hyperlink
//

%button-reset {
  border: none;
  background: none;
  -webkit-appearance: none;
}

button.button-reset {
  @extend %button-reset
}

%button {
  border-radius: $button-border-radius;
  padding: $button-spacing;
  display: inline-block;
  border: $button-border-width solid $button-border-color;
  font-family: $button-font-family;
  font-weight: $button-font-weight;
  line-height: 1;
  text-align: center;
  color: $button-text-color;
  background: $button-bg;
  background-image: none;
  white-space: nowrap;
  cursor: pointer;
  @include transition;

  &:hover {
    border-color: $button-border-color-hover;
    color: $button-text-color-hover;
  }
}

%button-highlighted {
  @extend %button;
  border-color: $color-highlight;
  background: $color-highlight;
  color: white;

  &:hover {
    background: transparent;
  }
}

%button-danger {
  @extend %button;
  border-color: $color-danger;
  background: $color-danger;
  color: white;

  &:hover {
    border-color: $color-danger;
    background: transparent;
    color: $color-danger;
  }
}

$button-styles: '', '-highlighted', '-danger';

@each $style in $button-styles {

  // button (default)
  a.button#{$style},
  button.button#{$style},
  span.button#{$style} {
    @extend %button#{$style};
  }

  div.button#{$style} {
    > a,
    > button {
      @extend %button#{$style};
    }

    // add margin, when there is another element following
    &:not(:last-child) {
      margin-bottom: $base-spacing-unit;
    }
  }
}
